#include <stdlib.h>
#include <iostream.h>
#include "Globals.hpp"
#include "AbEnds.hpp"
#include "TWBFind.h"

void BadUsage(char* cause, UCHAR type)
{
   cout << endl;

   switch (type)
      {
      case USAGE_HELP:
         break;

      case BAD_MIN_SECTORS:
         cout << "Invalid minimum number of sectors: " << cause << endl << endl;
         break;

      case BAD_MAX_SECTORS:
         cout << "Invalid maximum number of sectors: " << cause << endl << endl;
         break;

      case BAD_SECTOR_FILE:
         cout << "Bad sector data filename: " << cause << endl << endl;
         break;

      case BAD_REPORT_FILE:
         cout << "Bad report filename: " << cause << endl << endl;
         break;

      case BAD_TOTAL_SECTORS:
         cout << "Invalid number of sectors: " << cause << endl << endl;
         break;

      case BAD_PARAMETER:
         cout << "Invalid parameter: " << cause << endl << endl;
         break;

      case BAD_MAX_ENTRANCES:
         cout << "Invalid maximum number of entrances: " << cause << endl << endl;
         break;

      case BAD_ENT_MULTIPLIER:
         cout << "Invalid entrance multiplier: " << cause << endl << endl;
         break;

      #if (defined(__OS2__) || defined(__EMX__))
      case BAD_PRIORITY_CLASS:
         cout << "Invalid priority class: " << cause << endl << endl;
         break;

      case BAD_PRIORITY_DELTA:
         cout << "Invalid priority delta: " << cause << endl << endl;
         break;
      #endif
      }
   cout << "Usage: twbfind.exe [options]" << endl << endl;
   cout << "Options:" << endl << endl;
   cout << "/t  - use only one bubble route from primary entrance" << endl;
   cout << "/m# - minimum number of sectors in bubble; default 5" << endl;
   cout << "/x# - maximum number of sectors in bubble; default 50" << endl;
   cout << "/n# - number of sectors in universe (100 to 65535); default 1000" << endl;
   cout << "/e# - maximum number of entrances for bubbles (1 to 50); default 1" << endl;
   cout << "/z# - entrance multiplier for minimum bubble size (2.0 to 1000.0); default 2.0" << endl;
   #if (defined(__OS2__) || defined(__EMX__))
   cout << "/p# - priority class (1 to 4); default=2" << endl;
   cout << "/d# - priority delta (-31 to 31); default=0" << endl;
   #endif
   cout << "/s<filename> - sector data file" << endl;
   cout << "/o<filename> - report file; default 'bubbles.lst'" << endl;
   cout << endl;
   cout << "Example: twbfind /m6 /x25 /n5000 /ssectors.txt /obubbles.lst";
   cout << endl << endl;
   cout << "The above searches for bubbles with a minimum of 6 sectors and a maximum of";
   cout << endl << "25 sectors, with one entrance, in a 5000-sector universe, with data";
   cout << endl << "read from 'sectors.txt', and found bubbles written to the file";
   cout << endl << "'bubbles.lst'." << endl;
   exit(1);
}

void BadSector(char* sectNum, USHORT lineNum, UCHAR type)
{
   cout << endl << endl;
   cout << "Bad sector data on line " << lineNum << ": " << sectNum << endl;
   cout << endl;
   switch (type)
      {
      case BADSECT_UNSPECIFIED:
         break;

      case BADSECT_TOO_LARGE:
         cout << "Exceeds number of sectors (" << Globals::totalSectors << ")." << endl;
         break;

      case BADSECT_NOT_INTEGER:
         cout << "Not a valid integer." << endl;
         break;

      case BADSECT_DUP_DATA:
         cout << "Duplicate sector data." << endl;
         break;
      }
   exit(2);
}

void OutOfMemory(void)
{
   cout << endl;
   cout << "Out of memory." << endl;
   exit(3);
}
