#include "TWTypes.hpp"

class ofstream;
class TWSector;

class TWBubble
{
   public:

   TWBubble();
   TWBubble(USHORT entrance);
   TWBubble(TWBubble& copy);
   TWBubble& operator=(const TWBubble& assign);
   Bool operator==(const TWBubble& compare) const;
   ~TWBubble();

   USHORT numberOfSectors(void) const;
   USHORT entranceAtPosition(USHORT index) const;
   Bool addEntrance(USHORT entrance);
   USHORT numberOfEntrances(void) const;
   Bool hasEntrance(USHORT entrance) const;
   Bool addSector(USHORT newSect);
   USHORT sectorAtPosition(USHORT index) const;
   USHORT operator[](USHORT index) const;
   Bool hasSector(USHORT sectNum) const;
   Bool addBackDoor(USHORT sectNum);
   Bool isBackDoor(USHORT sectNum) const;
   Bool containsBubble(const TWBubble& subBub) const;
   void writeTo(ofstream& outFile) const;

   private:

   USHORT numSectors;
   USHORT *sectors;
   USHORT numEnts;
   USHORT *entrances;
   USHORT numBD;
   USHORT *back;
};

class TWBubbleSet
{
   public:

   TWBubbleSet();
   ~TWBubbleSet();

   TWBubbleSet& operator=(const TWBubbleSet& assign);
   Bool addBubble(const TWBubble& newBubble);
   USHORT numberOfBubbles(void);
   TWBubble& bubbleAtPosition(USHORT index);
   TWBubble& operator[](USHORT index);
   void trimBubblesTo(TWBubbleSet& keepSet);

   private:

   TWBubble *bubbles;
   USHORT numBubbles;
};
